#define __LIBRARY__
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
	
#define BUFFER_SIZE 10	/*  */
#define NUM 25			/* Ʒ */

#define __NR_sem_open 87
#define __NR_sem_wait 88
#define __NR_sem_post 89
#define __NR_sem_unlink 90

typedef void sem_t;  /* õsem_t*ģʵʶָ룬ڴ˽sem_t*ͶΪvoid*ͣ
						Ͳڴ¶sem_tĽṹ壬Ҳ˶ԽṹĹ
						¶˽ṹ壬ںҲѾ˴˽ṹ壬޸ģͬʱ
						Ҫ޸Ĵ˴ڴ洦Ľṹ */

_syscall2(int, sem_open, const char*, name, unsigned int, value)
_syscall1(int, sem_wait, sem_t *, sem)
_syscall1(int, sem_post, sem_t *, sem)
_syscall1(int, sem_unlink, const char *, name)

int main()
{	
	/* ע: ӦóвʹöϵȵԹ */
	int i, j;
	int consumeNum = 0; /* ѵĲƷ */
	int produceNum = 0; /* ĲƷ */
	int consume_pos = 0; /* ߴӹȡƷѵλ */
	int produce_pos = 0; /* Ʒλ */
	
	sem_t *empty, *full, *mutex;
	FILE *fp = NULL;
	pid_t producer_pid, consumer_pid;
	
	/* emptyfullmutexź */
	empty = (sem_t*)sem_open("empty", BUFFER_SIZE);
	full  = (sem_t*)sem_open("full", 0);
	mutex = (sem_t*)sem_open("mutex", 1);
	
	/* ļһ */
	fp=fopen("filebuffer.txt", "wb+");
	
	/* ߽ */
	if( !fork() )
	{
		producer_pid = getpid();
		printf("Producer pid=%d create success!\n", producer_pid);
		for( i = 0 ; i < NUM; i++)
		{
			sem_wait(empty);
			sem_wait(mutex);
			
			produceNum = i;
			
			/* ƶļα꣬зƷ */
			fseek(fp, produce_pos * sizeof(int), SEEK_SET);
			fwrite(&produceNum, sizeof(int), 1, fp);
			fflush(fp); 
			
			/* ƷϢ */
			printf("Producer pid=%d : %02d at %d\n", producer_pid, produceNum, produce_pos); 
			fflush(stdout);
			
			/* ߵαƶһλ */
			produce_pos = (produce_pos + 1) % BUFFER_SIZE;
			
			sem_post(mutex);
			sem_post(full);
			
			sleep(2);
		}
		exit(0);
	}
	
	/* ߽ */
	if( !fork() )
	{
		consumer_pid = getpid();
		printf("\t\t\tConsumer pid=%d create success!\n", consumer_pid);
		for( j = 0; j < NUM; j++ ) 
		{
			sem_wait(full);
			sem_wait(mutex);
			
			/* ƶļα꣬ȡеĲƷ */
			fseek(fp, consume_pos * sizeof(int), SEEK_SET);
			fread(&consumeNum, sizeof(int), 1, fp);
			fflush(fp);
			
			/* ѲƷϢ */
			printf("\t\t\tConsumer pid=%d: %02d at %d\n", consumer_pid, consumeNum, consume_pos);
			fflush(stdout);
			
			/* ߵαƶһλ */
			consume_pos = (consume_pos + 1) % BUFFER_SIZE;
	
			sem_post(mutex);
			sem_post(empty);
			
			if(j<4)	sleep(8);
			else sleep(1);
		}
		exit(0);
	}

	waitpid(producer_pid, NULL, 0);	/* ȴ߽̽ */
	waitpid(consumer_pid, NULL, 0);	/* ȴ߽̽ */
	
	/* رź */
	sem_unlink("empty");
	sem_unlink("full");
	sem_unlink("mutex");
	
	/* رļ */
	fclose(fp);
	
	return 0;
}
